/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
主要是进行以便签为单位的操作
什么是final类？
Java中有一些类，如String，Math等，就是final类的典型例子。
虽然在Java编程中并不经常使用final类和final方法，但它们有着与众不同的特点，
即final类不能被继承，不能被覆盖，以及final类在执行速度方面比一般类快。
 */


package net.micode.notes.model;
import android.content.ContentProviderOperation;
import android.content.ContentProviderResult;
import android.content.ContentUris;
import android.content.ContentValues;
import android.content.Context;
import android.content.OperationApplicationException;
import android.net.Uri;
import android.os.RemoteException;
import android.util.Log;

import net.micode.notes.data.Notes;
import net.micode.notes.data.Notes.CallNote;
import net.micode.notes.data.Notes.DataColumns;
import net.micode.notes.data.Notes.NoteColumns;
import net.micode.notes.data.Notes.TextNote;

import java.util.ArrayList;


public class Note {
    private ContentValues mNoteDiffValues;
    private NoteData mNoteData;
    private static final String TAG = "Note";
    /**
     * Create a new note id for adding a new note to databases
     */
    /**
     * 从数据库获取一个新的便签 ID。
     *
     * @param context   应用程序的上下文。
     * @param folderId  将要创建便签的文件夹 ID。
     * @return          新创建的便签 ID。
     */
    public static synchronized long getNewNoteId(Context context, long folderId) {
        // 在数据库中创建一个新的便签
        ContentValues values = new ContentValues();
        long createdTime = System.currentTimeMillis();
        values.put(NoteColumns.CREATED_DATE, createdTime);
        values.put(NoteColumns.MODIFIED_DATE, createdTime);
        values.put(NoteColumns.TYPE, Notes.TYPE_NOTE);
        values.put(NoteColumns.LOCAL_MODIFIED, 1);
        values.put(NoteColumns.PARENT_ID, folderId);
        Uri uri = context.getContentResolver().insert(Notes.CONTENT_NOTE_URI, values);

        long noteId = 0;
        try {
            noteId = Long.valueOf(uri.getPathSegments().get(1));
        } catch (NumberFormatException e) {
            Log.e(TAG, "获取便签 ID 出错：" + e.toString());
            noteId = 0;
        }
        if (noteId == -1) {
            throw new IllegalStateException("错误的便签 ID：" + noteId);
        }
        return noteId;
    }

    /**
     * 便签类的构造方法。
     * 初始化 mNoteDiffValues 和 mNoteData。
     */
    public Note() {
        mNoteDiffValues = new ContentValues();
        mNoteData = new NoteData();
    }

    /**
     * 用于设置便签数值的方法。
     *
     * @param key    要设置的数值的键。
     * @param value  要设置的数值。
     */
    public void setNoteValue(String key, String value) {
        mNoteDiffValues.put(key, value);
        mNoteDiffValues.put(NoteColumns.LOCAL_MODIFIED, 1);
        mNoteDiffValues.put(NoteColumns.MODIFIED_DATE, System.currentTimeMillis());
    }

    public void setTextData(String key, String value) {
        mNoteData.setTextData(key, value);
    }

    public void setTextDataId(long id) {
        mNoteData.setTextDataId(id);
    }

    public long getTextDataId() {
        return mNoteData.mTextDataId;
    }

    public void setCallDataId(long id) {
        mNoteData.setCallDataId(id);
    }

    public void setCallData(String key, String value) {
        mNoteData.setCallData(key, value);
    }

    public boolean isLocalModified() {
        return mNoteDiffValues.size() > 0 || mNoteData.isLocalModified();
    }




    public boolean syncNote(Context context, long noteId) {
        // 检查传入的noteId是否合法，如果不合法则抛出异常
        if (noteId <= 0) {
            throw new IllegalArgumentException("Wrong note id:" + noteId);
        }
        
        // 检查当前笔记是否有本地修改的内容，如果没有则直接返回true
        if (!isLocalModified()) {
            return true;
        }
        
        // 使用ContentResolver的update方法更新指定noteId的笔记数据，如果返回值为0，则表示更新失败
        if (context.getContentResolver().update(
                ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, noteId), mNoteDiffValues, null,
                null) == 0) {
            Log.e(TAG, "Update note error, should not happen");
            // 如果更新笔记失败，记录错误日志，但不立即返回，而是继续执行后面的逻辑
        }
        
        // 清空mNoteDiffValues，表示已经将本地修改的内容同步到了设备数据库
        mNoteDiffValues.clear();
        
        // 检查NoteData对象是否有本地修改的内容，如果有则将修改的内容推送到设备数据库中，如果返回值为null表示推送失败，则返回false
        if (mNoteData.isLocalModified()
                && (mNoteData.pushIntoContentResolver(context, noteId) == null)) {
            return false;
        }
        
        // 如果同步操作成功，则返回true
        return true;
    }




    private class NoteData {
        private long mTextDataId;

        private ContentValues mTextDataValues;

        private long mCallDataId;

        private ContentValues mCallDataValues;

        private static final String TAG = "NoteData";

        public NoteData() {
            mTextDataValues = new ContentValues();
            mCallDataValues = new ContentValues();
            mTextDataId = 0;
            mCallDataId = 0;
        }

        boolean isLocalModified() {
            return mTextDataValues.size() > 0 || mCallDataValues.size() > 0;
        }

        void setTextDataId(long id) {
            if(id <= 0) {
                throw new IllegalArgumentException("Text data id should larger than 0");
            }
            mTextDataId = id;
        }

        void setCallDataId(long id) {
            if (id <= 0) {
                throw new IllegalArgumentException("Call data id should larger than 0");
            }
            mCallDataId = id;
        }

        void setCallData(String key, String value) {
            mCallDataValues.put(key, value);
            mNoteDiffValues.put(NoteColumns.LOCAL_MODIFIED, 1);
            mNoteDiffValues.put(NoteColumns.MODIFIED_DATE, System.currentTimeMillis());
        }

        void setTextData(String key, String value) {
            mTextDataValues.put(key, value);
            mNoteDiffValues.put(NoteColumns.LOCAL_MODIFIED, 1);
            mNoteDiffValues.put(NoteColumns.MODIFIED_DATE, System.currentTimeMillis());
        }

        Uri pushIntoContentResolver(Context context, long noteId) {
            // 检查传入的noteId是否合法，如果不合法则抛出异常
            if (noteId <= 0) {
                throw new IllegalArgumentException("Wrong note id:" + noteId);
            }
        
            // 创建一个操作列表，用于存储要执行的ContentProvider操作
            ArrayList<ContentProviderOperation> operationList = new ArrayList<ContentProviderOperation>();
            ContentProviderOperation.Builder builder = null;
        
            // 如果mTextDataValues中有内容，则进行处理
            if(mTextDataValues.size() > 0) {
                // 设置mTextDataValues中的NOTE_ID字段为传入的noteId
                mTextDataValues.put(DataColumns.NOTE_ID, noteId);
                
                // 判断mTextDataId是否为0，如果为0说明是新创建的文本数据，需要执行插入操作
                if (mTextDataId == 0) {
                    // 设置mTextDataValues中的MIME_TYPE字段为TextNote的内容类型
                    mTextDataValues.put(DataColumns.MIME_TYPE, TextNote.CONTENT_ITEM_TYPE);
                    
                    // 使用ContentResolver的insert方法将mTextDataValues插入到设备数据库中，并获取插入的记录的Uri
                    Uri uri = context.getContentResolver().insert(Notes.CONTENT_DATA_URI, mTextDataValues);
                    
                    // 解析uri中的pathSegments获取插入的记录的ID，并将其设置为mTextDataId
                    try {
                        setTextDataId(Long.valueOf(uri.getPathSegments().get(1)));
                    } catch (NumberFormatException e) {
                        Log.e(TAG, "Insert new text data fail with noteId" + noteId);
                        mTextDataValues.clear();
                        return null;
                    }
                } else {
                    // 如果mTextDataId不为0，说明是已存在的文本数据，需要执行更新操作
                    builder = ContentProviderOperation.newUpdate(ContentUris.withAppendedId(
                            Notes.CONTENT_DATA_URI, mTextDataId));
                    builder.withValues(mTextDataValues);
                    operationList.add(builder.build());
                }
                
                // 清空mTextDataValues，表示mTextDataValues的内容已经处理完成
                mTextDataValues.clear();
            }
        
            // 如果mCallDataValues中有内容，则进行处理（处理逻辑与上述的文本数据类似）
            if(mCallDataValues.size() > 0) {
                mCallDataValues.put(DataColumns.NOTE_ID, noteId);
                if (mCallDataId == 0) {
                    mCallDataValues.put(DataColumns.MIME_TYPE, CallNote.CONTENT_ITEM_TYPE);
                    Uri uri = context.getContentResolver().insert(Notes.CONTENT_DATA_URI,
                            mCallDataValues);
                    try {
                        setCallDataId(Long.valueOf(uri.getPathSegments().get(1)));
                    } catch (NumberFormatException e) {
                        Log.e(TAG, "Insert new call data fail with noteId" + noteId);
                        mCallDataValues.clear();
                        return null;
                    }
                } else {
                    builder = ContentProviderOperation.newUpdate(ContentUris.withAppendedId(
                            Notes.CONTENT_DATA_URI, mCallDataId));
                    builder.withValues(mCallDataValues);
                    operationList.add(builder.build());
                }
                mCallDataValues.clear();
            }
        
            // 如果操作列表中有操作，则执行applyBatch方法将操作应用到设备数据库中
            if (operationList.size() > 0) {
                try {
                    // 使用ContentResolver的applyBatch方法将操作应用到设备数据库中，并获取操作结果
                    ContentProviderResult[] results = context.getContentResolver().applyBatch(
                            Notes.AUTHORITY, operationList);
                    
                    // 根据操作结果确定返回值
                    // 如果结果为null、长度为0或第一个结果为null，则返回null
                    // 否则返回指定noteId的笔记的Uri
                    return (results == null || results.length == 0 || results[0] == null) ? null
                            : ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, noteId);
                } catch (RemoteException e) {
                    Log.e(TAG, String.format("%s: %s", e.toString(), e.getMessage()));
                    return null;
                } catch (OperationApplicationException e) {
                    Log.e(TAG, String.format("%s: %s", e.toString(), e.getMessage()));
                    return null;
                }
            }
            
            // 如果操作列表为空，则直接返回null
            return null;
        }
    }
}
